#include "MainComponent.h"

//==============================================================================
MainComponent::MainComponent()
{
    setSize (600, 400);
    
    createCompButton.setButtonText("Create Component 1 With Shadows");
    addAndMakeVisible(createCompButton);
    createCompButton.onClick = [this]()
    {
        createComponentAndShadows();
    };
    
    deleteCompButton.setButtonText("Delete Component 1");
    addAndMakeVisible(deleteCompButton);
    deleteCompButton.onClick = [this]()
    {
        deleteComponent();
    };
}

MainComponent::~MainComponent()
{
}

//==============================================================================
void MainComponent::paint (juce::Graphics& g)
{
    g.fillAll (getLookAndFeel().findColour (juce::ResizableWindow::backgroundColourId));

}

void MainComponent::resized()
{
    createCompButton.setBounds(10, 10, 200, 20);
    deleteCompButton.setBounds(10, 40, 200, 20);

    if (testComponent != nullptr)
        testComponent->setBounds(200, 200, 100, 100);
}

void MainComponent::createComponentAndShadows()
{
    testComponent.reset();
    testComponent = std::make_shared<FilledComponent>();
    addAndMakeVisible(*testComponent);
    resized();
}

void MainComponent::deleteComponent()
{
    if (testComponent != nullptr)
    {
        testComponent->setVisible(false);
        testComponent.reset();
    }
}
