#pragma once

#include <JuceHeader.h>


class FilledComponent : public juce::Component
{
public:
    FilledComponent() : shadower_ (juce::DropShadow (juce::Colours::black, 40, juce::Point<int>(0,0)))
    {
        shadower_.setOwner (this);
    }
    
    void paint(juce::Graphics &g) override { g.fillAll(juce::Colours::blue); }
    
private:
    juce::DropShadower shadower_;
};

//==============================================================================
/*
    This component lives inside our window, and this is where you should put all
    your controls and content.
*/
class MainComponent  : public juce::Component
{
public:
    //==============================================================================
    MainComponent();
    ~MainComponent() override;

    //==============================================================================
    void paint (juce::Graphics&) override;
    void resized() override;
    
    void createComponentAndShadows();
    void deleteComponent();

private:
    //==============================================================================
    // Your private member variables go here...
    
    std::shared_ptr<FilledComponent> testComponent = nullptr;

    juce::TextButton createCompButton;
    juce::TextButton deleteCompButton;

    JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR (MainComponent)
};
